
mutable struct GCLayer
    W
    adj
    act
end
@functor GCLayer
Flux.trainable(nn::GCLayer) = (nn.W,)

function GCLayer(l2in::Integer, out::Integer, adj, act=relu; initW=glorot_uniform)
    W = Float32.(initW(l2in, out))
    return GCLayer(W, adj, act)
end

function (nonlayer::GCLayer)(x::AbstractArray)

    # println(size(x), " featmat")
    # println(size(nonlayer.W), " params")
    # println(size(nonlayer.adj), " adjmat")
    # println("other multiplication first")
    preact1 =  x * nonlayer.W
    # println(size(preact1), " preact1")
    # preact2 = nonlayer.adj * preact1
    # println(size(preact2), " preact2")
    return nonlayer.act.(nonlayer.adj * preact1)

    # need other direction otherwise softmax on cuarray won't work
    # preact1 =  nonlayer.W * x
    # println(size(preact1), " preact1")
    # return preact1 * nonlayer.adj
end

function preprocess(adjmat::AbstractArray)
    # if symmetric
    #     adjmat = Symmetric(adjmat)
    # end
    # if adjmat == zeros(size(adjmat))
    #     return adjmat
    # end
    adjmathat = adjmat + sparse(I, size(adjmat))
    # println(adjmathat)
    degrees = sum(adjmathat, dims=2)
    degrees = vec(degrees) .^ -0.5
    normD = spdiagm(0 => degrees)
    # normD[isinf.(normD)] .= 0
    return normD * adjmathat * normD
end
