
"""

Test doc
"""
function test()
    return "hello"
end

mutable struct NoNLayerSeparate
    l2W
    l1W
    l2adj
    l1adj
    l2act
    l1act
end
@functor NoNLayerSeparate
Flux.trainable(nn::NoNLayerSeparate) = (nn.l2W, nn.l1W)

function NoNLayerSeparate(l2in::Integer, l1in::Integer, out::Integer, l2adj, l1adj, l2act=relu, l1act=x -> relu.(x); initl2W=glorot_uniform, initl1W=glorot_uniform)
    l2W0 = Float32.(initl2W(l2in, out))
    # println(l2W0)
    l1W0 = [Float32.(initl1W(l1in, out)) for i in 1:length(l1adj)]
    return NoNLayerSeparate(l2W0, l1W0, l2adj, l1adj, l2act, l1act)
end
#
# function l2featsumhelper(x2, x1)
#     return x2 + reduce(hcat, transpose.(mean.(x1; dims=1)))'
# end
#
# function elementwiseadd(x, y)
#     return x .+ y'
# end
#
# function l1featsumhelper(x2, x1)
#     # println(size(x2), " x2")
#     # println(size(x2[7, :]'), " size of 7th row")
#     # println(length(x1), " x1")
#     # println(size(x1[1]), " x1[1]")
#     amounttorepeat = size(x1[1], 1)
#     # println(amounttorepeat, " repeats")
#
#     # repeatedx2 = []
#     # for i in 1:size(x2, 1)
#     #     row = x2[i, :]'
#     #     # println(size(row))
#     #     repeatedrow = repeat(row, outer=(amounttorepeat, 1))
#     #     # println(size(repeatedrow))
#     #     push!(repeatedx2, repeatedrow)
#     # end
#     repeatedx2 = [repeat(x2[i, :]', outer=(amounttorepeat, 1)) for i in 1:size(x2, 1)]
#     # println(length(repeatedx2))
#     # println(size(repeatedx2[1]))
#     return x1 .+ repeatedx2
#     # return elementwiseadd.(x1, [x2[i, :] for i in 1:size(x2, 1)])
#     # return map((x, y) -> x .+ y', x1, [x2[i, :] for i in 1:size(x2, 1)]) # should use transpose of x2 and [:, i], but afaik would require creating a copy of x2, which we want to avoid for memory reasons
# end

function (nonlayer::NoNLayerSeparate)((x2, x1)::Tuple{AbstractArray, AbstractArray})

    # x2 = Flux.gpu(x2)
    # nonlayer.l2W = Flux.gpu(nonlayer.l2W)
    # nonlayer.l2adj = Flux.gpu(nonlayer.l2adj)

    # temp2 = x2 * nonlayer.l2W
    o2 = nonlayer.l2act.(nonlayer.l2adj * x2 * nonlayer.l2W)
    # println(sizeof(o2))

    # x2 = Flux.cpu(x2)
    # nonlayer.l2W = Flux.cpu(nonlayer.l2W)
    # nonlayer.l2adj = Flux.cpu(nonlayer.l2adj)
    # o2 = Flux.cpu(o2)

    # x1 = Flux.gpu(x1)
    # nonlayer.l1W = Flux.gpu(nonlayer.l1W)
    # nonlayer.l1adj = Flux.gpu(nonlayer.l1adj)

    # pool = WorkerPool(collect(1:32))
    # temp1 = x1 .* nonlayer.l1W
    # o1 = nonlayer.l1act.(pmap(*, pool, nonlayer.l1adj, x1, nonlayer.l1W))
    o1 = nonlayer.l1act.(nonlayer.l1adj .* x1 .* nonlayer.l1W)
    # println(sizeof(o1))
    # x1 = Flux.cpu(x1)
    # nonlayer.l1W = Flux.cpu(nonlayer.l1W)
    # nonlayer.l1adj = Flux.cpu(nonlayer.l1adj)
    # o1 = Flux.cpu(o1)
    # o2 = l2featsumhelper(o2, o1)
    # o1 = l1featsumhelper(o2, o1)
    return (o2, o1)
end
