struct NoNLayer
    l2W
    l1W
    l2adj
    l1adj
    l2act
    l1act
end
@functor NoNLayer
Flux.trainable(nn::NoNLayer) = (nn.l2W, nn.l1W,)

function NoNLayer(l2in::Integer, l1in::Integer, out::Integer, l2adj, l1adj, l2act=relu, l1act=x -> relu.(x); initl2W=glorot_uniform, initl1W=glorot_uniform)
    # l2W0 = initl2W(l2in, out)
    # println(l2W0)
    # l1W0 = [initl1W(l1in, out) for i in 1:length(l1adj)]
    return NoNLayer(initl2W(l2in, out), [initl1W(l1in, out) for i in 1:length(l1adj)], l2adj, l1adj, l2act, l1act)
end

function l2featsumhelper(x2, x1)
    return x2 + reduce(hcat, transpose.(mean.(x1; dims=1)))'
end

function elementwiseadd(x, y)
    return x .+ y'
end

function l1featsumhelper(x2, x1)
    # println(size(x2), " x2")
    # println(size(x2[7, :]'), " size of 7th row")
    # println(length(x1), " x1")
    # println(size(x1[1]), " x1[1]")
    amounttorepeat = size(x1[1], 1)
    # println(amounttorepeat, " repeats")

    # repeatedx2 = []
    # for i in 1:size(x2, 1)
    #     row = x2[i, :]'
    #     # println(size(row))
    #     repeatedrow = repeat(row, outer=(amounttorepeat, 1))
    #     # println(size(repeatedrow))
    #     push!(repeatedx2, repeatedrow)
    # end
    repeatedx2 = [repeat(x2[i, :]', outer=(amounttorepeat, 1)) for i in 1:size(x2, 1)]
    # println(length(repeatedx2))
    # println(size(repeatedx2[1]))
    return x1 .+ repeatedx2
    # return elementwiseadd.(x1, [x2[i, :] for i in 1:size(x2, 1)])
    # return map((x, y) -> x .+ y', x1, [x2[i, :] for i in 1:size(x2, 1)]) # should use transpose of x2 and [:, i], but afaik would require creating a copy of x2, which we want to avoid for memory reasons
end
function (nonlayer::NoNLayer)((x2, x1)::Tuple{AbstractArray, AbstractArray})
    o2 = nonlayer.l2act.(nonlayer.l2adj * l2featsumhelper(x2, x1) * nonlayer.l2W)
    o1 = nonlayer.l1act.(nonlayer.l1adj .* l1featsumhelper(x2, x1) .* nonlayer.l1W)
    return (o2, o1)
end

# function preprocess(adjmat::AbstractArray; symmetric=true)
#     if symmetric
#         adjmat = Symmetric(adjmat)
#     end
#     if adjmat == zeros(size(adjmat))
#         return adjmat
#     end
#     adjmathat = adjmat + I
#     # println(adjmathat)
#     normD = Diagonal(reshape(sum(adjmathat, dims=2), size(adjmathat, 1))) .^ -0.5
#     normD[isinf.(normD)] .= 0
#     return normD * adjmathat * normD
# end
