struct NoNLayerNoAdj
    l2W
    l1W
    l2act
    l1act
end
@functor NoNLayerNoAdj
Flux.trainable(nn::NoNLayerNoAdj) = (nn.l2W, nn.l1W,)

function NoNLayerNoAdj(l2in::Integer, l1in::Integer, out::Integer l2act=relu, l1act=x -> relu.(x); initl2W=glorot_uniform, initl1W=glorot_uniform)
    l2W0 = initl2W(l2in, out)
    # println(l2W0)
    l1W0 = [initl1W(l1in, out) for i in 1:length(l1adj)]
    return NoNLayerNoAdj(l2W0, l1W0, l2act, l1act)
end

function l2featsumhelper(x2, x1)
    return x2 + reduce(hcat, transpose.(mean.(x1; dims=1)))'
end
function l1featsumhelper(x2, x1)
    return map((x, y) -> x .+ y', x1, [x2[i, :] for i in 1:size(x2, 1)]) # should use transpose of x2 and [:, i], but afaik would require creating a copy of x2, which we want to avoid for memory reasons
end
function (NoNLayerNoAdj::NoNLayerNoAdj)((x2, x1, a2, a1)::Tuple{AbstractArray, AbstractArray})
    o2 = NoNLayerNoAdj.l2act.(a2 * l2featsumhelper(x2, x1) * NoNLayerNoAdj.l2W)
    o1 = NoNLayerNoAdj.l1act.(a1 .* l1featsumhelper(x2, x1) .* NoNLayerNoAdj.l1W)
    return (o2, o1)
end

function preprocess(adjmat::AbstractArray; symmetric=true)
    if symmetric
        adjmat = Symmetric(adjmat)
    end
    if adjmat == zeros(size(adjmat))
        return adjmat
    end
    adjmathat = adjmat + I
    # println(adjmathat)
    normD = Diagonal(reshape(sum(adjmathat, dims=2), size(adjmathat, 1))) .^ -0.5
    normD[isinf.(normD)] .= 0
    return normD * adjmathat * normD
end
