struct NoNLayerv2
    l2W
    l1W
    l2adj
    l1adj
    l2act
    l1act
end
@functor NoNLayerv2
Flux.trainable(nn::NoNLayerv2) = (nn.l2W, nn.l1W,)

function NoNLayerv2(l2in::Integer, l1in::Integer, out::Integer, l2adj, l1adj, l2act=relu, l1act=x -> relu.(x); initl2W=glorot_uniform, initl1W=glorot_uniform)#initl1W=(x, y) -> sprand(x, y, 0.1))##
    l2W0 = initl2W(l2in, out)
    l1W0 = initl1W(l1in, out)
    # l1W0 = [initl1W(l1in, l1out) for i in 1:length(l1adj)]
    return NoNLayerv2(l2W0, l1W0, l2adj, l1adj, l2act, l1act)
end

function l2featsumhelperv2(x2, x1)
    return x2 + reduce(hcat, transpose.(mean.(x1; dims=1)))'
end
function l1featsumhelperv2(x2, x1)
    return map((x, y) -> x .+ y', x1, [x2[i, :] for i in 1:size(x2, 1)]) # should use transpose of x2 and [:, i], but afaik would require creating a copy of x2, which we want to avoid for memory reasons
end
function (nonlayer::NoNLayerv2)((x2, x1)::Tuple{AbstractArray, AbstractArray})
    # println(size(x2), " x2")
    # println(size(x1[1]), " x1[1]")
    # println(size(nonlayer.l2adj), " l2adj")
    # println(size(nonlayer.l1adj), " l1adjs")
    # println(size(nonlayer.l1adj[1]), " l1adj")
    # println(size(nonlayer.l2W), " l2W")
    # println(size(nonlayer.l1W), " l1W")
    o2 = nonlayer.l2act.(nonlayer.l2adj * l2featsumhelperv2(x2, x1) * nonlayer.l2W)
    o1 = nonlayer.l1act.(map(x -> x * nonlayer.l1W, nonlayer.l1adj .* l1featsumhelperv2(x2, x1)))
    # println(size(o2), " o2")
    # println(size(o1), " o1")
    # o1 = nonlayer.l1act.(nonlayer.l1adj .* l1featsumhelperv2(x2, x1) .* nonlayer.l1W)
    # o1 = nonlayer.l1act.([nonlayer.l1adj[i] * l1featsumhelperv2(x2, x1)[i] * nonlayer.l1W for i in 1:length(nonlayer.l1adj)])
    return (o2, o1)
end

# function preprocess(adjmat::AbstractArray; symmetric=true)
#     if symmetric
#         adjmat = Symmetric(adjmat)
#     end
#     if adjmat == zeros(size(adjmat))
#         return adjmat
#     end
#     adjmathat = adjmat + I
#     # println(adjmathat)
#     normD = Diagonal(reshape(sum(adjmathat, dims=2), size(adjmathat, 1))) .^ -0.5
#     normD[isinf.(normD)] .= 0
#     return normD * adjmathat * normD
# end


struct DenseEnd{F,S<:AbstractArray}
  W::S
  σ::F
end

DenseEnd(W) = DenseEnd(W, identity)

function DenseEnd(in::Integer, out::Integer, σ = identity;
               initW = glorot_uniform)
  return DenseEnd(initW(in, out), σ)
end

@functor DenseEnd

function (a::DenseEnd)(x::AbstractArray)
  W, σ = a.W, a.σ
  σ.(x*W)
end
