

# @testset "helpers" begin
#
#
#         helperout = l1featsumhelper(x2, x1)
# end
# exit()

@testset "NoN GCN layer separate" begin

        l2adj = [0 1 1;
                 1 0 0;
                 1 0 0]
        l2adj = l2adj + I
        l2feats = [1 3 5;
                   2 4 6]
        Random.seed!(0);
        l2W = Flux.glorot_uniform(2, 4)
        # [0.5487213 -0.52411556 -0.74392104 -0.053299665;
               # 0.82237625 0.7357681 -0.76736426 0.59150076]
        temp = l2feats' * l2W # [6.1 7.0 7.9 8.8; 7.6 8.8 10.0 11.2]
        o = l2adj * temp
        @test round.(o; digits=2) == Float32[14.81 4.11 -15.9 6.62;
                                      7.13 2.32 -7.58 3.34;
                                      9.87 2.74 -10.6 4.41]

        l1adj = [[0 1 1; 1 0 0; 1 0 0], [0 1 1; 1 0 1; 1 1 0]]
        l1adj = l1adj .+ [I for i in 1:length(l1adj)]
        l1feats = [[1 3 5; 2 4 6], [-1 -3 -5; -2 -4 -6]]

        l1W = [Flux.glorot_uniform(2, 4) for i in 1:length(l1adj)]
        temp1 = map(x -> x', l1feats) .* l1W
        o1 = l1adj .* temp1
        @test map(x -> round.(x; digits=2), o1) == map(x -> round.(Float32.(x); digits=2), [[-9.339684 14.709369 19.536346 10.345005; -4.8051434 7.139865 9.300125 5.1391883; -6.2264557 9.806246 13.024231 6.8966703], [9.132849 11.762137 7.2062235 3.4498272; 9.132849 11.762137 7.2062235 3.4498272; 9.132849 11.762137 7.2062235 3.4498272]])

        Random.seed!(0)
        nonlayer = NoNLayerSeparate(2, 2, 4, l2adj, l1adj)
        (interm_l2feats, interm_l1feats) = nonlayer((l2feats', map(x -> x', l1feats)))
        @test round.(relu.(o); digits=2) == round.(Float32.(interm_l2feats); digits=2)
        @test map(x -> round.(relu.(x); digits=2), o1) == map(x -> round.(Float32.(x); digits=2), interm_l1feats)

        # model = Chain(NoNLayerSeparate(2, 2, 8, l2adj, l1adj), NoNLayerSeparate(8, 8, 4, l2adj, l1adj))
        # model = Flux.gpu(model)
        # l2feats = Flux.gpu(l2feats')
        # l1feats = Flux.gpu(map(x -> x', l1feats))
        # (x2, x1) = model((l2feats, l1feats))
        # println(typeof(x2))
        # println(typeof(x1))

        # channels = 256
        # featsize = 15
        # l2n = 15000
        # numl1nets = 15000
        # timel2adj = sprand(Float16, l2n, l2n, 0.005)
        # timel1adj = [sprand(Float16, 200, 200, 0.05) for i in 1:numl1nets]
        # timemodel = Chain(NoNLayerSeparate(featsize, featsize, channels, timel2adj, timel1adj), NoNLayerSeparate(channels, channels, channels, timel2adj, timel1adj), NoNLayerSeparate(channels, channels, 4, timel2adj, timel1adj))
        # timel2feats = rand(l2n, featsize)
        # timel1feats = [rand(200, featsize) for i in 1:numl1nets]
        # # @time timemodel((timel2feats, timel1feats))
        # timemodel = Flux.gpu(timemodel)
        # timel2feats = Flux.gpu(timel2feats)
        # timel1feats = Flux.gpu(timel1feats)
        # @time timemodel((timel2feats, timel1feats))

end

@testset "NoN GCN layer together" begin

        l2adj = [0 1 1;
                 1 0 0;
                 1 0 0]
        l2adjproc = preprocess(l2adj)
        @test round.(l2adjproc; digits=2) == round.([0.333333  0.408248  0.408248; 0.408248  0.5       0.0; 0.408248  0.0       0.5]; digits=2)

        l2feats = [1 3 5;
                   2 4 6]
        l1adj = [[0 1 1; 1 0 0; 1 0 0], [0 1 1; 1 0 1; 1 1 0], [0 0 1; 0 0 1; 1 1 0]]
        l1adjproc = preprocess.(l1adj)
        @test map(x->round.(x; digits=2), l1adjproc) == map(x->round.(x; digits=2), [[0.3333333333333334 0.408248290463863 0.408248290463863; 0.408248290463863 0.4999999999999999 0.0; 0.408248290463863 0.0 0.4999999999999999], [0.3333333333333334 0.3333333333333334 0.3333333333333334; 0.3333333333333334 0.3333333333333334 0.3333333333333334; 0.3333333333333334 0.3333333333333334 0.3333333333333334], [0.4999999999999999 0.0 0.408248290463863; 0.0 0.4999999999999999 0.408248290463863; 0.408248290463863 0.408248290463863 0.3333333333333334]])

        l1feats = [[1 3 5; 2 4 6], [-1 -3 -5; -2 -4 -6], [7 8 9; 10 11 12]]
        @test l2featsumhelper(l2feats', transpose.(l1feats)) == [4 6; 0 0; 13 17]
        @test l1featsumhelper(l2feats', transpose.(l1feats)) == [[2 4; 4 6; 6 8], [2 2; 0 0; -2 -2], [12 16; 13 17; 14 18]]
        Random.seed!(0)
        nonlayer = NoNLayer(2, 2, 4, l2adjproc, l1adjproc)
        (interm_l2feats, interm_l1feats) = nonlayer((l2feats', transpose.(l1feats)))
        @test round.(interm_l2feats; digits=2) == round.([10.996042794134604 3.097507771333244 0.0 4.934207785966082; 2.9104603447451627 0.946379234948884 0.0 1.361837053113805; 13.467347017718792 3.7936567570359796 0.0 6.043145680242405] ; digits=2)
        @test map(x -> round.(x; digits=2), interm_l1feats) == map(x -> round.(x; digits=2), [[0.0 8.409382628374216 10.972553300702886 6.040854123022856; 0.0 5.396225105335757 6.926462902591084 3.950169935251127; 0.0 6.729415546467349 8.788515820071554 4.82891096117581], [0.0 0.0 0.0 0.0; 0.0 0.0 0.0 0.0; 0.0 0.0 0.0 0.0], [0.0 0.0 0.0 0.9370457673491899; 0.0 0.0 0.0 1.0635339761199418; 0.0 0.0 0.0 1.1967202410172144]])
        # @test round.(relu.(o); digits=2) == round.(Float32.(interm_l2feats); digits=2)
        # @test map(x -> round.(relu.(x); digits=2), o1) == map(x -> round.(Float32.(x); digits=2), interm_l1feats)
        #
        # model = Chain(NoNLayer(2, 2, 8, l2adj, l1adj), NoNLayer(8, 8, 4, l2adj, l1adj))
        # model = Flux.gpu(model)
        # l2feats = Flux.gpu(l2feats')
        # l1feats = Flux.gpu(map(x -> x', l1feats))
        # (x2, x1) = model((l2feats, l1feats))
        # println(typeof(x2))
        # println(typeof(x1))

        channels = 256
        featsize = 15
        l2n = 10000
        numl1nets = 10000
        timel2adj = sprand(Float16, l2n, l2n, 0.005)
        timel1adj = [sprand(Float16, 200, 200, 0.05) for i in 1:numl1nets]
        timemodel = Chain(NoNLayer(featsize, featsize, channels, timel2adj, timel1adj), NoNLayer(channels, channels, 4, timel2adj, timel1adj))
        timel2feats = rand(l2n, featsize)
        timel1feats = [rand(200, featsize) for i in 1:numl1nets]
        @time timemodel((timel2feats, timel1feats))
        timemodel = Flux.gpu(timemodel)
        timel2feats = Flux.gpu(timel2feats)
        timel1feats = Flux.gpu(timel1feats)
        @time timemodel((timel2feats, timel1feats))

end
