module SyntheticNoNs

# import LightGraphs:
# 	AbstractGraph,
# 	vertices
using LightGraphs
using Random
using StatsBase
using YAML

import Base: zero

import Distributed: @everywhere, pmap

using LinearAlgebra: rmul!, norm

using DataStructures: PriorityQueue, enqueue!, dequeue!

export
	AbstractNoN,
	NoN,
	InterEdge,
	GraphOfGroups,
	add_interedge!,
	rem_interedge!,
	to_simple_graph,
	add_graph!,
	rem_graph!,
	NoNType,
	# assign_upper!,
	assign_lower!,
	nvg,

	erdos_renyi_nm,
	gen_er,
	barabasi_albert_nm,
	gen_sf,
	euclidean_graph_nm,
	euclidean_graph_top,
	gen_geo,
	gen_synthetic_non,
	gen_er_non_from_non,
	_map_to_sequential!,

	rewire_edges!,

	EdgeListDelimFormat,
	FlexibleEdgeListFormat,
	GMLFormat2,
	savenon,
	save2levelnon,
	savegraph,

	testsynthnons

include("non.jl")
include("generators.jl")
include("noise.jl")
include("io.jl")

testsynthnons() = println("tested dev package")

end # module
