using StatsBase
getRNG(seed::Integer=-1) = seed >= 0 ? MersenneTwister(seed) : GLOBAL_RNG
function rewire_edges!(G::SimpleGraph{T}, percent::Float64; seed=-1) where T

    n = nv(G)
    rng = getRNG(seed)
    # if seed > -1
    #     Random.seed!(seed)
    # end

    elist = collect(edges(G))
    numedgestoremove = round(Int, length(elist) * percent)
    edgestoremove = sample(rng, elist, numedgestoremove; replace=false)
    for e in edgestoremove
        rem_edge!(G, e)
    end
    # println("removed $(length(edgestoremove)) edges, G now has $(ne(G)) edges")
    # c = 0
    while numedgestoremove > 0
        ind1 = rand(rng, 1:n)
        ind2 = rand(rng, 1:n)
        if ind1 == ind2
            continue
        end
        newe = Edge(ind1, ind2)
        if has_edge(G, newe) || has_edge(G, reverse(newe))
            continue
        end
        add_edge!(G, newe)
        # println(newe)
        # c += 1
        numedgestoremove -= 1
    end
    # println("added $c edges")

end
