
@testset "Noise tests" begin
    models = [gen_er, gen_geo, gen_sf]
    ns = [200]
    ms = [800]
    noises = [0., 0.05, 0.1, 0.25, 0.5, 0.75, 0.9, 0.95, 1.]
    for n in ns
        for m in ms
            for (mind, model) in enumerate(models)
                for noise in noises
                    @testset "model$model $n $m $noise" begin
                        G = model(n, m)
                        oriG = deepcopy(G)
                        rewire_edges!(G, noise)
                        if noise == 0.
                            @test G == oriG
                        end
                        @test ne(G) == ne(oriG)
                        # intersecting_edges = intersect(collect(edges(G)), collect(edges(oriG)))
                        # @test (1-noise) * ne(oriG) * 0.8 <= length(intersecting_edges) <= (1-noise) * ne(oriG) * 1.2
                        # need to find a formula for expected number of edges to overlap
                        @testset "Random seed tests" begin
                            if noise == 0.
                                continue
                            end
                            for i in 1:5
                                G1 = model(n, m)
                                G2 = model(n, m)
                                rewire_edges!(G2, noise)
                                @test G1 != G2

                                G3 = model(n, m; seed=i)
                                G4 = model(n, m; seed=i)
                                rewire_edges!(G3, noise; seed=i)
                                rewire_edges!(G4, noise; seed=i)
                                @test G3 == G4
                                rewire_edges!(G3, noise; seed=i)
                                rewire_edges!(G4, noise; seed=i+1)
                                @test G3 != G4
                            end
                        end
                    end
                end
            end
        end
    end
end
