import numpy as np;
import random;
import networkx as netx;
import sys;
import time;
import scipy;
import multiprocessing as mp;
from functools import partial
import os;
import subprocess;
import copy
import glob;



# l1names = ["geo", "sf", "er"]
# l1namestring = l1names.join("-")
# l1n = 200
# l1m = 800
# l2names = ["geo", "sf", "er"]
# l2namestring = l2names.join("-")
# l2n = 15030
# l2m = 300000
# l2numgroupsper = 5
# l2acrosspercent = 0.05
# rewirepercent = 0.0

# outdir = f"/scratch/sgu3/non-embedding/data/{l1namestring}_{l1n}_{l1m}_{l2namestring}_{l2n}_{l2m}_{l2numgroupsper}_{l2acrosspercent}_{rewirepercent}/"

def l1loader(i, l1dir, padto):
	l1f = f"{l1dir}/l1_{str(i).zfill(len(str(padto)))}.gml.txt"
	G = netx.read_gml(l1f)
	A = netx.adjacency_matrix(G).todense()
	return A

def read_labels(infile):
	labels = [];
	with open(infile, "r") as fi:
		for line in fi:
			larr = list(map(lambda x: int(float(x)), line.split()));
			labels.append(larr)

	return np.array(labels);

def loadnon(nondir, l2n, numprocs=1):
	l2G = netx.read_gml(f"{nondir}/l2/l2.gml.txt")
	l2A = netx.adjacency_matrix(l2G).todense();


	l1As = []
	pool = mp.Pool(numprocs);
	partial_l1loader = partial(l1loader, l1dir=f"{nondir}/l1/", padto=l2n)
	l1As += pool.map(partial_l1loader, range(1, l2n+1))
	pool.close()
	pool.join()

	labels = read_labels(f"{nondir}/labels.onehot.txt");

	return l1As, l2A, labels;

def generate_masks_nnodes(l2n, nclasses, perc, sd=0):
	trainmask = np.ones(l2n, dtype=bool);
	valmask = np.zeros(l2n, dtype=bool);
	testmask = np.zeros(l2n, dtype=bool);
	np.random.seed(sd)
	i = 0
	used = set([])
	while(len(used) < int(l2n * perc)):

		randind = np.random.randint(0, int(l2n/nclasses))
		if randind in used:
			continue;
		used.add(randind)
		if i < int(l2n * perc/2):
			for j in range(1, nclasses):
				trainmask[randind] = False;
				trainmask[randind + j * int(l2n/nclasses)] = False;
				valmask[randind] = True;
				valmask[randind + j * int(l2n/nclasses)] = True;
		else:
			for j in range(1, nclasses):
				trainmask[randind] = False;
				trainmask[randind + j * int(l2n/nclasses)] = False;
				testmask[randind] = True;
				testmask[randind + j * int(l2n/nclasses)] = True;
		i += 1;

	return trainmask, valmask, testmask;






